using System;
using System.Threading;

namespace ThreadClass
{
	class Test
	{
		private static void LongRunningMethod()
		{
			try
			{
				Console.WriteLine("Method started");
				Thread.Sleep(10000);
				Console.WriteLine("Method complete");
			}
			catch(ThreadAbortException ex)
			{
				Console.WriteLine("Thread aborted..." + ex);
			}
		}

		[STAThread]
		static void Main(string[] args)
		{
			try
			{
				Thread th = new Thread(new ThreadStart(LongRunningMethod));
				th.IsBackground = true;
				th.Start();

				Thread.Sleep(2000);
				Console.WriteLine("Aborting thread");
				th.Abort();

				Thread.Sleep(1000);
				Console.WriteLine();
				Console.WriteLine("---------- Staring another thread");
				th = new Thread(new ThreadStart(LongRunningMethod));
				th.IsBackground = true;
				th.Start();

				Thread.Sleep(2000);
				Console.WriteLine("Main done");
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex);
			}
		}
	}
}
