using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace ThreadSynchronization
{
	public class MainForm : System.Windows.Forms.Form
	{
		private int count;

		private System.Windows.Forms.TextBox counterTB;
		private System.Windows.Forms.Button incrementButton;
		private System.Windows.Forms.Button decrementButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.counterTB = new System.Windows.Forms.TextBox();
			this.incrementButton = new System.Windows.Forms.Button();
			this.decrementButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// counterTB
			// 
			this.counterTB.Enabled = false;
			this.counterTB.Location = new System.Drawing.Point(56, 24);
			this.counterTB.Name = "counterTB";
			this.counterTB.Size = new System.Drawing.Size(184, 20);
			this.counterTB.TabIndex = 0;
			this.counterTB.Text = "counterValue";
			// 
			// incrementButton
			// 
			this.incrementButton.Location = new System.Drawing.Point(48, 112);
			this.incrementButton.Name = "incrementButton";
			this.incrementButton.Size = new System.Drawing.Size(72, 32);
			this.incrementButton.TabIndex = 1;
			this.incrementButton.Text = "Increment";
			this.incrementButton.Click += new System.EventHandler(this.incrementButton_Click);
			// 
			// decrementButton
			// 
			this.decrementButton.Location = new System.Drawing.Point(168, 112);
			this.decrementButton.Name = "decrementButton";
			this.decrementButton.Size = new System.Drawing.Size(72, 32);
			this.decrementButton.TabIndex = 1;
			this.decrementButton.Text = "Decrement";
			this.decrementButton.Click += new System.EventHandler(this.decrementButton_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.decrementButton,
																		  this.incrementButton,
																		  this.counterTB});
			this.Name = "MainForm";
			this.Text = "Contention";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			counterTB.Text = "" + count;
		}

		private void incrementButton_Click(object sender, System.EventArgs e)
		{
			new Thread(new ThreadStart(increment)).Start();
		}

		private void decrementButton_Click(object sender, System.EventArgs e)
		{
			new Thread(new ThreadStart(decrement)).Start();
		}

		public void increment()
		{
			// Generally timing problems and contentation are hard to
			// catch. Invariably, they happen when you do not expect
			// or want it to happen (like in a demo to clients).
			// In order to simulate the problem, we have written the code
			// in an un-natural way.

			incrementButton.Enabled = false;
			lock(this)
			{
				int val = count;
				Thread.Sleep(5000);
				count = val + 1;
				counterTB.Text = "" + count;
			}
			incrementButton.Enabled = true;
		}

		public void decrement()
		{
			// Generally timing problems and contentation are hard to
			// catch. Invariably, they happen when you do not expect
			// or want it to happen (like in a demo to clients).
			// In order to simulate the problem, we have written the code
			// in an un-natural way.

			decrementButton.Enabled = false;
			lock(this)
			{
				int val = count;
				Thread.Sleep(5000);
				count = val - 1;
				counterTB.Text = "" + count;
			}
			decrementButton.Enabled = true;
		}
	}
}
